include graphics.e
include palette.e

-- Text-mode fades using palette.e
-- by Jacob Hammond (c) 1999, for ZIG
-- 2/3/99 - created
-- 2/3/99 - added speed factors
-- 4/8/99 - added sounds fades

global procedure fade_out(atom speed, atom snd)

sequence xpal
xpal = repeat({0,0,0}, 16)

for z = 0 to 15 do
    xpal[z + 1] = get_palette(z)
end for

for z = 63 to 0 by -speed do
    if snd != 0 and integer(z / 5) then
        volume_down()
    end if
    for a = 0 to 15 do
        for b = 1 to 3 do            
            xpal[a + 1][b] = xpal[a + 1][b] - speed
            if xpal[a + 1][b] < 0 then xpal[a + 1][b] = 0 end if
        end for
        set_palette(a, xpal[a + 1])
    end for
end for

end procedure

global procedure fade_in(atom speed, atom snd)

sequence xpal, lpal
xpal = repeat({0,0,0}, 16)
lpal = repeat({0,0,0}, 16)

for z = 0 to 15 do
    lpal[z + 1] = palette(z, {0,0,0})
end for

for z = 0 to 63 by 1 do
    if snd != 0 and integer(z / 5) then
        volume_up()
    end if
    for a = 0 to 15 do
        for b = 1 to 3 do            
            xpal[a + 1][b] = xpal[a + 1][b] + speed
            if xpal[a + 1][b] > lpal[a + 1][b] then xpal[a + 1][b] = lpal[a + 1][b] end if
        end for
        set_palette(a, xpal[a + 1])
    end for
end for

end procedure

